<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">

<head>
  <title>KMainWindow</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="Content-Style-Type" content="text/css" />
  <link rel="stylesheet" type="text/css" href="../common/doxygen.css" />
  <link rel="stylesheet" media="screen" type="text/css" title="KDE Colors" href="../common/kde.css" />
</head>
<body>
<div id="container">
<div id="header">
  <div id="header_top">
    <div>
      <div>
        <img alt ="" src="../common/top-kde.jpg"/>
        KDE 4.2 PyKDE API Reference
      </div>
    </div>
  </div>
  <div id="header_bottom">
    <div id="location">
      <ul>
        <li>KDE's Python API</li>
      </ul>
    </div>

    <div id="menu">
      <ul>
        <li><a href="../modules.html">Overview</a></li>
<li><a href="http://techbase.kde.org/Development/Languages/Python">PyKDE Home</a></li>
<li><a href="http://kde.org/family/">Sitemap</a></li>
<li><a href="http://kde.org/contact/">Contact Us</a></li>
</ul>
    </div>
  </div>
</div>

<div id="body_wrapper">
<div id="body">
<div id="right">
<div class="content">
<div id="main">
<div class="clearer">&nbsp;</div>

<h1>KMainWindow Class Reference</h1>
<code>from PyKDE4.kdeui import *</code>
<p>
Inherits: <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qmainwindow.html">QMainWindow</a> &#x2192; <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qwidget.html">QWidget</a> &#x2192; <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a><br />
Subclasses: <a href="../kdeui/KXmlGuiWindow.html">KXmlGuiWindow</a><br />

<h2>Detailed Description</h2>

<p>%KDE top level main window
</p>
<p>
Top level widget that provides toolbars, a status line and a frame.
</p>
<p>
It should be used as a top level (parent-less) widget.
It manages the geometry for all its children, including your
main widget.
</p>
<p>
Normally, you will inherit from KMainWindow,
then construct (or use some existing) widget as
your main view. You can set only one main view.
</p>
<p>
You can add as many toolbars as you like. There can be only one menubar
and only one statusbar.
</p>
<p>
The toolbars, menubar, and statusbar can be created by the
KMainWindow and - unlike the old KMainWindow - may, but do not
have to, be deleted by you. KMainWindow will handle that internally.
</p>
<p>
Height and width can be operated independently from each other. Simply
define the minimum/maximum height/width of your main widget and
KMainWindow will take this into account. For fixed size windows set
your main widget to a fixed size.
</p>
<p>
Fixed aspect ratios (heightForWidth()) and fixed width widgets are
not supported.
</p>
<p>
KMainWindow will set icon, mini icon and caption, which it gets
from KApplication. It provides full session management, and
will save its position, geometry and positions of toolbars and
menubar on logout. If you want to save additional data, reimplement
saveProperties() and (to read them again on next login)
readProperties(). To save special data about your data, reimplement
saveGlobalProperties(). To warn user that application or
windows have unsaved data on close or logout, reimplement
queryClose() and/or queryExit().
</p>
<p>
There are also kRestoreMainWindows convenience functions which
can restore all your windows on next login.
</p>
<p>
Note that KMainWindow uses KGlobal.ref() and KGlobal.deref() so that closing
the last mainwindow will quit the application unless there is still something
that holds a ref in KGlobal - like a KIO job, or a systray icon.
</p>
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd> KApplication
</dd></dl> 
<dl class="author" compact><dt><b>Author:</b></dt><dd> Reginald Stadlbauer (reggie@kde.org) Stephan Kulow (coolo@kde.org), Matthias Ettrich (ettrich@kde.org), Chris Schlaeger (cs@kde.org), Sven Radej (radej@kde.org). Maintained by David Faure (faure@kde.org) </dd></dl>
</p>
<table border="0" cellpadding="0" cellspacing="0"><tr><td colspan="2"><br><h2>Methods</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198575052">__init__</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qwidget.html">QWidget</a> parent=0, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qt.html">Qt.WindowFlags</a> f=0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198644396">__init__</a> (self, KMainWindowPrivate dd, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qwidget.html">QWidget</a> parent, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qt.html">Qt.WFlags</a> f)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198614924">appHelpActivated</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198600204">applyMainWindowSettings</a> (self, <a href="../kdecore/KConfigGroup.html">KConfigGroup</a> config, bool force=0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="../kdecore/KConfigGroup.html">KConfigGroup</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198601708">autoSaveConfigGroup</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198601196">autoSaveGroup</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198600172">autoSaveSettings</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198619340">closeEvent</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qcloseevent.html">QCloseEvent</a> a0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="../kdeui/KMenu.html">KMenu</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198576972">customHelpMenu</a> (self, bool showWhatsThis=1)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198612396">dbusName</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198619436">event</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qevent.html">QEvent</a> event)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198587980">hasMenuBar</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="../kdeui/KMenu.html">KMenu</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198575916">helpMenu</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> aboutAppText=QString(), bool showWhatsThis=1)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198602732">ignoreInitialGeometry</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198611596">initialGeometrySet</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="../kdeui/KMenuBar.html">KMenuBar</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198587788">menuBar</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198635212">parseGeometry</a> (self, bool parsewidth)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198621196">queryClose</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198620620">queryExit</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198620044">readGlobalProperties</a> (self, <a href="../kdecore/KConfig.html">KConfig</a> sessionConfig)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198622476">readProperties</a> (self, <a href="../kdecore/KConfigGroup.html">KConfigGroup</a> a0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198632940">readPropertiesInternal</a> (self, <a href="../kdecore/KConfig.html">KConfig</a> a0, int a1)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198600396">resetAutoSaveSettings</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198587212">restore</a> (self, int number, bool show=1)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198634636">restoreWindowSize</a> (self, <a href="../kdecore/KConfigGroup.html">KConfigGroup</a> config)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198633900">saveAutoSaveSettings</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198622988">saveGlobalProperties</a> (self, <a href="../kdecore/KConfig.html">KConfig</a> sessionConfig)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198602668">saveMainWindowSettings</a> (self, <a href="../kdecore/KConfigGroup.html">KConfigGroup</a> config)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198621004">saveProperties</a> (self, <a href="../kdecore/KConfigGroup.html">KConfigGroup</a> a0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198632300">savePropertiesInternal</a> (self, <a href="../kdecore/KConfig.html">KConfig</a> a0, int a1)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198633996">saveWindowSize</a> (self, <a href="../kdecore/KConfigGroup.html">KConfigGroup</a> config)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198590316">setAutoSaveSettings</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> groupName=QLatin1String("MainWindow"), bool saveWindowSize=1)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198599692">setAutoSaveSettings</a> (self, <a href="../kdecore/KConfigGroup.html">KConfigGroup</a> group, bool saveWindowSize=1)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198611468">setCaption</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> caption)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198612940">setCaption</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> caption, bool modified)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198613612">setPlainCaption</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> caption)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198614380">setSettingsDirty</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198633612">settingsDirty</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198633484">showAboutApplication</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="../kdeui/KStatusBar.html">KStatusBar</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198588716">statusBar</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="../kdeui/KToolBar.html">KToolBar</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198589260">toolBar</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> name=QString())</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">[KToolBa]&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198590284">toolBars</a> (self)</td></tr>
<tr><td colspan="2"><br><h2>Static Methods</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198575276">canBeRestored</a> (int number)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198578124">classNameOfToplevel</a> (int number)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">[KMainWindo]&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198589164">memberList</a> ()</td></tr>
</table>
<hr><h2>Method Documentation</h2><a class="anchor" name="obj198575052"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">__init__</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qwidget.html">QWidget</a>&nbsp;</td>
<td class="paramname"><em>parent=0</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qt.html">Qt.WindowFlags</a>&nbsp;</td>
<td class="paramname"><em>f=0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Construct a main window.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>parent</em>&nbsp;</td><td> The widget parent. This is usually 0 but it may also be the window
group leader. In that case, the KMainWindow becomes sort of a
secondary window.
</td></tr>

<tr><td></td><td valign="top"><em>f</em>&nbsp;</td><td> Specify the window flags. The default is none.
</td></tr>
</table></dl>
<p> Note that a KMainWindow per-default is created with the
WA_DeleteOnClose attribute, i.e. it is automatically destroyed when the
window is closed. If you do not want this behavior, call
setAttribute(Qt.WA_DeleteOnClose, false);
</p>
<p>
KMainWindows must be created on the heap with 'new', like:
<pre class="fragment">
 KMainWindow *kmw = new KMainWindow(...);
 kmw-&gt;setObjectName(...);
</pre>
</p>
<p>
IMPORTANT: For session management and window management to work
properly, all main windows in the application should have a
different name. If you don't do it, KMainWindow will create
a unique name, but it's recommended to explicitly pass a window name that will
also describe the type of the window. If there can be several windows of the same
type, append '#' (hash) to the name, and KMainWindow will replace it with numbers to make
the names unique. For example, for a mail client which has one main window showing
the mails and folders, and which can also have one or more windows for composing
mails, the name for the folders window should be e.g. "mainwindow" and
for the composer windows "composer#".
</p></div></div><a class="anchor" name="obj198644396"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">__init__</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">KMainWindowPrivate&nbsp;</td>
<td class="paramname"><em>dd</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qwidget.html">QWidget</a>&nbsp;</td>
<td class="paramname"><em>parent</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qt.html">Qt.WFlags</a>&nbsp;</td>
<td class="paramname"><em>f</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"></div></div><a class="anchor" name="obj198614924"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> appHelpActivated</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Open the help page for the application.
</p>
<p>
The application name is
used as a key to determine what to display and the system will attempt
to open &lt;appName&gt;/index.html.
</p>
<p>
This method is intended for use by a help button in the toolbar or
components outside the regular help menu. Use helpMenu() when you
want to provide access to the help system from the help menu.
</p>
<p>
Example (adding a help button to the first toolbar):
</p>
<p>
<pre class="fragment">
 toolBar(0)-&gt;addAction(KIcon("help-contents"), i18n("Help"),
                       this, SLOT(appHelpActivated()));
</pre>
</p></div></div><a class="anchor" name="obj198600204"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> applyMainWindowSettings</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../kdecore/KConfigGroup.html">KConfigGroup</a>&nbsp;</td>
<td class="paramname"><em>config</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">bool&nbsp;</td>
<td class="paramname"><em>force=0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Read settings for statusbar, menubar and toolbar from their respective
groups in the config file and apply them.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>config</em>&nbsp;</td><td> Config group to read the settings from.

<tr><td></td><td valign="top"><em>force</em>&nbsp;</td><td> if set, even default settings are re-applied
</td></tr>
</table></dl>
<p>
</p></div></div><a class="anchor" name="obj198601708"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="../kdecore/KConfigGroup.html">KConfigGroup</a> autoSaveConfigGroup</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p><dl class="return" compact><dt><b>Returns:</b></dt><dd> the group used for setting-autosaving.
Only meaningful if setAutoSaveSettings() was called.
This can be useful for forcing an apply, e.g. after using KEditToolbar.
</dd></dl> <dl class="since" compact><dt><b>Since:</b></dt><dd> 4.1
</dd></dl>
</p></div></div><a class="anchor" name="obj198601196"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> autoSaveGroup</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p><dl class="return" compact><dt><b>Returns:</b></dt><dd> the group used for setting-autosaving.
Only meaningful if setAutoSaveSettings(QString) was called.
This can be useful for forcing a save or an apply, e.g. before and after
using KEditToolbar.
</dd></dl> </p>
<p>
NOTE: you should rather use saveAutoSaveSettings() for saving or autoSaveConfigGroup() for loading.
This method doesn't make sense if setAutoSaveSettings(KConfigGroup) was called.
</p></div></div><a class="anchor" name="obj198600172"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">bool autoSaveSettings</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p><dl class="return" compact><dt><b>Returns:</b></dt><dd> the current autosave setting, i.e. true if setAutoSaveSettings() was called,
false by default or if resetAutoSaveSettings() was called.
</dd></dl>
</p></div></div><a class="anchor" name="obj198575276"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">bool canBeRestored</td>
<td>(</td>
<td class="paramtype">int&nbsp;</td>
<td class="paramname"><em>number</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p><b>Session Management</b>
</p>
<p>
Try to restore the toplevel widget as defined by the number (1..X).
</p>
<p>
If the session did not contain so high a number, the configuration
is not changed and <b>false</b> returned.
</p>
<p>
That means clients could simply do the following:
<pre class="fragment">
 if (qApp-&gt;isSessionRestored()){
   int n = 1;
   while (KMainWindow.canBeRestored(n)){
     (new childMW)-&gt;restore(n);
     n++;
   }
 } else {
   // create default application as usual
 }
</pre>
Note that QWidget.show() is called implicitly in restore.
</p>
<p>
With this you can easily restore all toplevel windows of your
application.
</p>
<p>
If your application uses different kinds of toplevel
windows, then you can use KMainWindow.classNameOfToplevel(n)
to determine the exact type before calling the childMW
constructor in the example from above.
</p>
<p>
If your client has only one kind of toplevel widgets (which
should be pretty usual) then you should use the RESTORE-macro
for backwards compatibility with 3.1 and 3.0 branches:
</p>
<p>
<pre class="fragment">
 if (qApp-&gt;isSessionRestored())
   RESTORE(childMW)
 else {
   // create default application as usual
 }
</pre>
</p>
<p>
The macro expands to the term above but is easier to use and
less code to write.
</p>
<p>
For new code or if you have more than one kind of toplevel
widget (each derived from KMainWindow, of course), you can
use the templated kRestoreMainWindows global functions:
</p>
<p>
<pre class="fragment">
 if (qApp-&gt;isSessionRestored())
   kRestoreMainWindows&lt; childMW1, childMW2, childMW3 &gt;();
 else {
   // create default application as usual
 }
</pre>
</p>
<p>
Currently, these functions are provided for up to three
template arguments. If you need more, tell us. To help you in
deciding whether or not you can use kRestoreMainWindows, a
define KDE_RESTORE_MAIN_WINDOWS_NUM_TEMPLATE_ARGS is provided.
</p>
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd> restore()
</dd></dl> <dl class="see" compact><dt><b>See also:</b></dt><dd> classNameOfToplevel()
</dd></dl>
</p></div></div><a class="anchor" name="obj198578124"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> classNameOfToplevel</td>
<td>(</td>
<td class="paramtype">int&nbsp;</td>
<td class="paramname"><em>number</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Returns the className() of the <b>number</b> of the toplevel window which
should be restored.
</p>
<p>
This is only useful if your application uses
different kinds of toplevel windows.
</p></div></div><a class="anchor" name="obj198619340"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> closeEvent</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qcloseevent.html">QCloseEvent</a>&nbsp;</td>
<td class="paramname"><em>a0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Reimplemented to call the queryClose() and queryExit() handlers.
</p>
<p>
We recommend that you reimplement the handlers rather than closeEvent().
If you do it anyway, ensure to call the base implementation to keep
queryExit() running.
</p></div></div><a class="anchor" name="obj198576972"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="../kdeui/KMenu.html">KMenu</a> customHelpMenu</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">bool&nbsp;</td>
<td class="paramname"><em>showWhatsThis=1</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Returns the help menu. Creates a standard help menu if none exists yet.
</p>
<p>
It contains entries for the
help system (activated by F1), an optional "What's This?" entry
(activated by Shift F1), an application specific dialog box,
and an "About KDE" dialog box. You must create the application
specific dialog box yourself. When the "About application"
menu entry is activated, a signal will trigger the
showAboutApplication slot. See showAboutApplication for more
information.
</p>
<p>
Example (adding a help menu to your application):
<pre class="fragment">
 menuBar()-&gt;addMenu( customHelpMenu() );
</pre>
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>showWhatsThis</em>&nbsp;</td><td> Set this to <b>false</b> if you do not want to include
the "What's This" menu entry.
</td></tr>
</table></dl>
<p> <dl class="return" compact><dt><b>Returns:</b></dt><dd> A standard help menu.
</dd></dl>
</p></div></div><a class="anchor" name="obj198612396"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> dbusName</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Returns the path under which this window's D-Bus object is exported.
<dl class="since" compact><dt><b>Since:</b></dt><dd> 4.0.1
</dd></dl>
</p></div></div><a class="anchor" name="obj198619436"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">bool event</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qevent.html">QEvent</a>&nbsp;</td>
<td class="paramname"><em>event</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Reimplemented to catch QEvent.Polish in order to adjust the object name
if needed, once all constructor code for the main window has run.
Also reimplemented to catch when a QDockWidget is added or removed.
</p></div></div><a class="anchor" name="obj198587980"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">bool hasMenuBar</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Returns true, if there is a menubar
</p></div></div><a class="anchor" name="obj198575916"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="../kdeui/KMenu.html">KMenu</a> helpMenu</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>aboutAppText=QString()</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">bool&nbsp;</td>
<td class="paramname"><em>showWhatsThis=1</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Retrieve the standard help menu.
</p>
<p>
It contains entries for the
help system (activated by F1), an optional "What's This?" entry
(activated by Shift F1), an application specific dialog box,
and an "About KDE" dialog box.
</p>
<p>
Example (adding a standard help menu to your application):
<pre class="fragment">
 KMenu *help = helpMenu( &lt;myTextString&gt; );
 menuBar()-&gt;addMenu( help );
</pre>
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>aboutAppText</em>&nbsp;</td><td> The string that is used in the application
specific dialog box. If you leave this string empty the
information in the global KAboutData of the
application will be used to make a standard dialog box.
</td></tr>

<tr><td></td><td valign="top"><em>showWhatsThis</em>&nbsp;</td><td> Set this to false if you do not want to include
the "What's This" menu entry.
</td></tr>
</table></dl>
<p> <dl class="return" compact><dt><b>Returns:</b></dt><dd> A standard help menu.
</dd></dl>
</p></div></div><a class="anchor" name="obj198602732"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> ignoreInitialGeometry</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p><dl class="internal" compact><dt><b>Internal:</b></dt><dd>
Used from Konqueror when reusing the main window.
</dd></dl>
</p></div></div><a class="anchor" name="obj198611596"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">bool initialGeometrySet</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p><dl class="return" compact><dt><b>Returns:</b></dt><dd> true if a -geometry argument was given on the command line,
and this is the first window created (the one on which this option applies)
</dd></dl>
</p></div></div><a class="anchor" name="obj198589164"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">[KMainWindo] memberList</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname">)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>List of members of KMainWindow class.
</p></div></div><a class="anchor" name="obj198587788"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="../kdeui/KMenuBar.html">KMenuBar</a> menuBar</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Returns a pointer to the menu bar.
</p>
<p>
If there is no menu bar yet one will be created.
</p></div></div><a class="anchor" name="obj198635212"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> parseGeometry</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">bool&nbsp;</td>
<td class="paramname"><em>parsewidth</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>parse the geometry from the geometry command line argument
</p></div></div><a class="anchor" name="obj198621196"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">bool queryClose</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Called before the window is closed, either by the user or indirectly by
the session manager.
</p>
<p>
The purpose of this function is to prepare the window in a way that it is
safe to close it, i.e. without the user losing some data.
</p>
<p>
Default implementation returns true. Returning <b>false</b> will cancel
the closing, and, if KApplication.sessionSaving() is true, it will also
cancel KDE logout.
</p>
<p>
Reimplement this function to prevent the user from losing data.
Example:
<pre class="fragment">
switch ( KMessageBox.warningYesNoCancel( this,
i18n("Save changes to document foo?")) ) {
case KMessageBox.Yes :
// save document here. If saving fails, return false;
return true;
case KMessageBox.No :
return true;
default: // cancel
return false;
</pre>
</p>
<p>
Note that you should probably <b>not</b> actually close the document from
within this method, as it may be called by the session manager before the
session is saved. If the document is closed before the session save occurs,
its location might not be properly saved. In addition, the session shutdown
may be canceled, in which case the document should remain open.
</p>
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd> queryExit()
</dd></dl> <dl class="see" compact><dt><b>See also:</b></dt><dd> KApplication.sessionSaving()
</dd></dl>
</p></div></div><a class="anchor" name="obj198620620"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">bool queryExit</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Called before the very last window is closed, either by the
user or indirectly by the session manager.
</p>
<p>
It is not recommended to do any user interaction in this
function other than indicating severe errors. Better ask the
user on queryClose() (see below).
</p>
<p>
A typical usage of queryExit() is to write configuration data back.
Note that the application may continue to run after queryExit()
(the user may have canceled a shutdown), so you should not do any cleanups
here. The purpose of queryExit() is purely to prepare the application
(with possible user interaction) so it can safely be closed later (without
user interaction).
</p>
<p>
If you need to do serious things on exit (like shutting a
dial-up connection down), connect to the signal
QCoreApplication.aboutToQuit().
</p>
<p>
Default implementation returns <b>true.</b> Returning <b>false</b> will
cancel the exiting. In the latter case, the last window will
remain visible. If KApplication.sessionSaving() is true, refusing
the exit will also cancel KDE logout.
</p>
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd> queryClose()
</dd></dl> <dl class="see" compact><dt><b>See also:</b></dt><dd> KApplication.sessionSaving()
</dd></dl>
</p></div></div><a class="anchor" name="obj198620044"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> readGlobalProperties</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../kdecore/KConfig.html">KConfig</a>&nbsp;</td>
<td class="paramname"><em>sessionConfig</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>The counterpart of saveGlobalProperties().
</p>
<p>
Read the application-specific properties in again.
</p></div></div><a class="anchor" name="obj198622476"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> readProperties</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../kdecore/KConfigGroup.html">KConfigGroup</a>&nbsp;</td>
<td class="paramname"><em>a0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Read your instance-specific properties.
</p></div></div><a class="anchor" name="obj198632940"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">bool readPropertiesInternal</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../kdecore/KConfig.html">KConfig</a>&nbsp;</td>
<td class="paramname"><em>a0</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">int&nbsp;</td>
<td class="paramname"><em>a1</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"></div></div><a class="anchor" name="obj198600396"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> resetAutoSaveSettings</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Disable the auto-save-settings feature.
You don't normally need to call this, ever.
</p></div></div><a class="anchor" name="obj198587212"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">bool restore</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">int&nbsp;</td>
<td class="paramname"><em>number</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">bool&nbsp;</td>
<td class="paramname"><em>show=1</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Restore the session specified by <b>number.</b>
</p>
<p>
Returns <b>false</b> if this
fails, otherwise returns <b>true</b> and shows the window.
You should call canBeRestored() first.
If <b>show</b> is true (default), this widget will be shown automatically.
</p></div></div><a class="anchor" name="obj198634636"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> restoreWindowSize</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../kdecore/KConfigGroup.html">KConfigGroup</a>&nbsp;</td>
<td class="paramname"><em>config</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>For inherited classes
Note that a -geometry on the command line has priority.
</p></div></div><a class="anchor" name="obj198633900"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> saveAutoSaveSettings</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>This slot should only be called in case you reimplement closeEvent() and
if you are using the "auto-save" feature. In all other cases,
setSettingsDirty() should be called instead to benefit from the delayed
saving.
</p>
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd> setAutoSaveSettings
</dd></dl> <dl class="see" compact><dt><b>See also:</b></dt><dd> setSettingsDirty
</dd></dl> </p>
<p>
Example:
<pre class="fragment">

 void MyMainWindow.closeEvent( QCloseEvent *e )
 {
   // Save settings if auto-save is enabled, and settings have changed
   if ( settingsDirty() &amp;&amp; autoSaveSettings() )
     saveAutoSaveSettings();
   ..
 }
</pre>
</p></div></div><a class="anchor" name="obj198622988"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> saveGlobalProperties</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../kdecore/KConfig.html">KConfig</a>&nbsp;</td>
<td class="paramname"><em>sessionConfig</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Save your application-wide properties. The function is
invoked when the session manager requests your application
to save its state.
</p>
<p>
This function is similar to saveProperties() but is only called for
the very first main window, regardless how many main window are open.
</p>
<p>
Override it if you need to save other data about your documents on
session end. sessionConfig is a config to which that data should be
saved. Normally, you don't need this function. But if you want to save
data about your documents that are not in opened windows you might need
it.
</p>
<p>
Default implementation does nothing.
</p></div></div><a class="anchor" name="obj198602668"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> saveMainWindowSettings</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../kdecore/KConfigGroup.html">KConfigGroup</a>&nbsp;</td>
<td class="paramname"><em>config</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Save settings for statusbar, menubar and toolbar to their respective
groups in the config group <b>config.</b>
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>config</em>&nbsp;</td><td> Config group to save the settings to.
</td></tr>
</table></dl>
<p>
</p></div></div><a class="anchor" name="obj198621004"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> saveProperties</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../kdecore/KConfigGroup.html">KConfigGroup</a>&nbsp;</td>
<td class="paramname"><em>a0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Save your instance-specific properties. The function is
invoked when the session manager requests your application
to save its state.
</p>
<p>
Please reimplement these function in childclasses.
</p>
<p>
Note: No user interaction is allowed
in this function!
</p></div></div><a class="anchor" name="obj198632300"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> savePropertiesInternal</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../kdecore/KConfig.html">KConfig</a>&nbsp;</td>
<td class="paramname"><em>a0</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">int&nbsp;</td>
<td class="paramname"><em>a1</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"></div></div><a class="anchor" name="obj198633996"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> saveWindowSize</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../kdecore/KConfigGroup.html">KConfigGroup</a>&nbsp;</td>
<td class="paramname"><em>config</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>For inherited classes
</p></div></div><a class="anchor" name="obj198590316"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> setAutoSaveSettings</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>groupName=QLatin1String("MainWindow")</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">bool&nbsp;</td>
<td class="paramname"><em>saveWindowSize=1</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Call this to enable "auto-save" of toolbar/menubar/statusbar settings
(and optionally window size).
If the *bars were moved around/shown/hidden when the window is closed,
saveMainWindowSettings( KConfigGroup(KGlobal.config(), groupName) ) will be called.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>groupName</em>&nbsp;</td><td> a name that identifies this "type of window".
You can have several types of window in the same application.
</td></tr>

<tr><td></td><td valign="top"><em>saveWindowSize</em>&nbsp;</td><td> set it to true to include the window size
when saving.
</td></tr>
</table></dl>
<p> Typically, you will call setAutoSaveSettings() in your
KMainWindow-inherited class constructor, and it will take care
of restoring and saving automatically. Make sure you call this
_after all_ your *bars have been created.
</p>
<p>
To make sure that KMainWindow propertly obtains the default
size of the window you should do the following:
- Remove hard coded resize() calls in the constructor or main, they
should be removed in favor of letting the automatic resizing
determine the default window size. Hard coded window sizes will
be wrong for users that have big fonts, use different styles,
long/small translations, large toolbars, and other factors.
- Put the setAutoSaveSettings ( or setupGUI() ) call after all widgets
have been created and placed inside the main window (i.e. for 99% of
apps setCentralWidget())
- Widgets that inherit from QWidget (like game boards) should overload
"virtual QSize sizeHint() const;" to specify a default size rather
than letting QWidget.adjust use the default size of 0x0.
</p></div></div><a class="anchor" name="obj198599692"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> setAutoSaveSettings</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../kdecore/KConfigGroup.html">KConfigGroup</a>&nbsp;</td>
<td class="paramname"><em>group</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">bool&nbsp;</td>
<td class="paramname"><em>saveWindowSize=1</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Overload that lets you specify a KConfigGroup.
This allows the settings to be saved into another file than KGlobal.config().
<dl class="since" compact><dt><b>Since:</b></dt><dd> 4.1
</dd></dl>
</p></div></div><a class="anchor" name="obj198611468"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> setCaption</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>caption</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Makes a KDE compliant caption (window title).
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>caption</em>&nbsp;</td><td> Your caption. <b>Do</b> <b>not</b> include the application name
in this string. It will be added automatically according to the KDE
standard.
</td></tr>
</table></dl>
<p>
</p></div></div><a class="anchor" name="obj198612940"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> setCaption</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>caption</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">bool&nbsp;</td>
<td class="paramname"><em>modified</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Makes a KDE compliant caption.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>caption</em>&nbsp;</td><td> Your caption. <b>Do</b> <b>not</b> include the application name
in this string. It will be added automatically according to the KDE
standard.

<tr><td></td><td valign="top"><em>modified</em>&nbsp;</td><td> Specify whether the document is modified. This displays
an additional sign in the title bar, usually "**".
</td></tr>
</table></dl>
<p>
</p></div></div><a class="anchor" name="obj198613612"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> setPlainCaption</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>caption</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Make a plain caption without any modifications.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>caption</em>&nbsp;</td><td> Your caption. This is the string that will be
displayed in the window title.
</td></tr>
</table></dl>
<p>
</p></div></div><a class="anchor" name="obj198614380"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> setSettingsDirty</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Tell the main window that it should save its settings when being closed.
This is part of the auto-save-settings feature.
For everything related to toolbars this happens automatically,
but you have to call setSettingsDirty() in the slot that toggles
the visibility of the statusbar.
</p></div></div><a class="anchor" name="obj198633612"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">bool settingsDirty</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>For inherited classes
</p></div></div><a class="anchor" name="obj198633484"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> showAboutApplication</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>This slot does nothing.
</p>
<p>
It must be reimplemented if you want
to use a custom About Application dialog box. This slot is
connected to the About Application entry in the menu returned
by customHelpMenu.
</p>
<p>
Example:
<pre class="fragment">

 void MyMainLevel.setupInterface()
 {
   ..
   menuBar()-&gt;addMenu( customHelpMenu() );
   ..
 }

 void MyMainLevel.showAboutApplication()
 {
   &lt;activate your custom dialog&gt;
 }
</pre>
</p></div></div><a class="anchor" name="obj198588716"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="../kdeui/KStatusBar.html">KStatusBar</a> statusBar</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Returns a pointer to the status bar.
</p>
<p>
If there is no status bar yet, one will be created.
</p>
<p>
Note that tooltips for kactions in actionCollection() are not
automatically connected to this statusBar.
See the KActionCollection documentation for more details.
</p>
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd> KActionCollection
</dd></dl>
</p></div></div><a class="anchor" name="obj198589260"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="../kdeui/KToolBar.html">KToolBar</a> toolBar</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>name=QString()</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Returns a pointer to the toolbar with the specified name.
This refers to toolbars created dynamically from the XML UI
framework. If the toolbar does not exist one will be created.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>name</em>&nbsp;</td><td> The internal name of the toolbar. If no name is
specified "mainToolBar" is assumed.
</td></tr>
</table></dl>
<p> <dl class="return" compact><dt><b>Returns:</b></dt><dd> A pointer to the toolbar
</dd></dl>
</p></div></div><a class="anchor" name="obj198590284"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">[KToolBa] toolBars</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p><dl class="return" compact><dt><b>Returns:</b></dt><dd> A list of all toolbars for this window
</dd></dl>
</p></div></div>
</div>
</div>
</div>

<div id="left">

<div class="menu_box">
<div class="nav_list">
<ul>
<li><a href="../allclasses.html">Full Index</a></li>
</ul>
</div>

<a name="cp-menu" /><div class="menutitle"><div>
  <h2 id="cp-menu-project">Modules</h2>
</div></div>
<div class="nav_list">
<ul>
<li><a href="../akonadi/index.html">akonadi</a></li>
<li><a href="../dnssd/index.html">dnssd</a></li>
<li><a href="../kdecore/index.html">kdecore</a></li>
<li><a href="../kdeui/index.html">kdeui</a></li>
<li><a href="../khtml/index.html">khtml</a></li>
<li><a href="../kio/index.html">kio</a></li>
<li><a href="../knewstuff/index.html">knewstuff</a></li>
<li><a href="../kparts/index.html">kparts</a></li>
<li><a href="../kutils/index.html">kutils</a></li>
<li><a href="../nepomuk/index.html">nepomuk</a></li>
<li><a href="../phonon/index.html">phonon</a></li><li><a href="../plasma/index.html">plasma</a></li>
<li><a href="../solid/index.html">solid</a></li>
<li><a href="../soprano/index.html">soprano</a></li>
</ul></div></div>

</div>

</div>
  <div class="clearer"/>
</div>

<div id="end_body"></div>
</div>
<div id="footer"><div id="footer_text">
This documentation is maintained by <a href="&#109;&#97;&#105;&#108;&#116;&#111;&#58;simon&#64;simonzone&#46;com">Simon Edwards</a>.<br />
        KDE<sup>&#174;</sup> and <a href="../images/kde_gear_black.png">the K Desktop Environment<sup>&#174;</sup> logo</a> are registered trademarks of <a href="http://ev.kde.org/" title="Homepage of the KDE non-profit Organization">KDE e.V.</a> |
        <a href="http://www.kde.org/contact/impressum.php">Legal</a>
    </div></div>
</body>
</html>
